//-----------------------------------------------------------------------------
//
//			->	 22 -    Direct3D
//			->	http://www.firststeps.ru
//	  02.09.2002
//  :      ->    evgeniu@atnet.ru
//-----------------------------------------------------------------------------
#include "afxwin.h"						// MFC    

#define APPNAME "http://www.firststeps.ru    22 -    Direct3D"
#include <d3d8.h>
#include <d3dx8math.h>
#include <mmsystem.h>
#include "font.h"
#pragma comment (lib, "d3d8.lib")
#pragma comment (lib, "d3dx8.lib")

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };};
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };};

#define D3DFVF_CUSTOMVERTEX ( D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)

struct CUSTOMVERTEX { float x, y, z, nx, ny, nz, tu, tv; };

class CMainWnd : public CFrameWnd
{
private:
	LPDIRECT3D8             p_d3d;						//    
	LPDIRECT3DDEVICE8		p_d3d_Device;				//   d3d8
	D3DDISPLAYMODE			d3ddm;						//  
	D3DPRESENT_PARAMETERS	d3dpp;						//  
	LPDIRECT3DVERTEXBUFFER8 p_VertexBuffer;				//   
	LPDIRECT3DTEXTURE8		textura001;					//  
	LPD3DXMESH				p_d3dx_mesh;				//  
	LPDIRECT3DTEXTURE8*     g_pMeshTextures;			//   
	DWORD                   g_dwNumMaterials;			//    
	D3DMATERIAL8*           g_pMeshMaterials;			//   
	D3DXMATRIX				matWorld;					//  
    D3DXMATRIX				matView;					//  
    D3DXMATRIX				matProj;					//  
	D3DLIGHT8				light;						//  
	D3DMATERIAL8			mtrl1;                      //  
	D3DMATERIAL8			mtrl2;						//  
	D3DMATERIAL8			mtrl3;						//  
	Font					MyFont;						//  
	DECLARE_MESSAGE_MAP()
public:
	D3DXVECTOR3 vecDir;									//   
	                                                    // 
	CMainWnd();											//   
	~CMainWnd(void);									//   
	void Transform3D(void);
	void LoadMesh (char *filename);						//   
	afx_msg void OnPaint();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
};

BEGIN_MESSAGE_MAP(CMainWnd, CFrameWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()

CMainWnd::~CMainWnd(void)
{
	_RELEASE_	(p_d3dx_mesh);
    _DELETE_	(p_d3dx_mesh);
	//_RELEASE_	(textura001);
	//_DELETE_	(textura001);
	_RELEASE_	(p_VertexBuffer);
	_DELETE_	(p_VertexBuffer);
	_RELEASE_	(p_d3d_Device);
	_DELETE_	(p_d3d_Device);
	_RELEASE_	(p_d3d);
	_DELETE_	(p_d3d);
}

CMainWnd::CMainWnd()
{ 
	p_VertexBuffer = NULL;
	p_d3dx_mesh = NULL;

	HFONT hFont = CreateFont(
		24,							//  
		0,							// 
		0,							//    
		0,							//    
		FW_NORMAL,					//  
		FALSE,						// 
		FALSE,						// 
		0,							// 
		ANSI_CHARSET,				//  
		OUT_DEFAULT_PRECIS,			// nOutPrecision
		CLIP_DEFAULT_PRECIS,		// nClipPrecision
		DEFAULT_QUALITY,			// 
		DEFAULT_PITCH | FF_SWISS,	//   
		"Arial");					//  

	CUSTOMVERTEX g_Vertices[] =
	{
		{ -100.0f,   0.0f,  0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f,},
		{ -100.0f, 180.0f,  0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f,},
		{  100.0f, 180.0f,  0.0f, 0.0f, 0.0f, 0.0f, 6.0f, 0.0f,},

		{ -100.0f,   0.0f, 0.0f, 0.0f, 0.0f,  0.0f, 0.0f, 1.0f,},
		{  100.0f, 180.0f, 0.0f, 0.0f, 0.0f,  0.0f, 6.0f, 0.0f,},
		{  100.0f,   0.0f, 0.0f, 0.0f, 0.0f,  0.0f, 6.0f, 1.0f,},
	};

	Create(NULL, APPNAME,				//   
		WS_POPUP,
		rectDefault, NULL,NULL);

	p_d3d = Direct3DCreate8 (D3D_SDK_VERSION);
	
	p_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm);

	ZeroMemory (&d3dpp, sizeof(d3dpp));
	d3dpp.BackBufferWidth = 1024;
	d3dpp.BackBufferHeight = 768;
	d3dpp.BackBufferCount = 3;
	d3dpp.FullScreen_RefreshRateInHz = d3ddm.RefreshRate;
	d3dpp.Windowed = false;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = d3ddm.Format;
	d3dpp.EnableAutoDepthStencil = true;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D32;

	p_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, m_hWnd, 
		D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &p_d3d_Device);

	p_d3d_Device->CreateVertexBuffer (sizeof(g_Vertices), 
		0, 
		D3DFVF_CUSTOMVERTEX, D3DPOOL_MANAGED, 
		&p_VertexBuffer);

	VOID* pVertices;
	p_VertexBuffer->Lock (0, sizeof(g_Vertices), (BYTE**)&pVertices, 0);
	memcpy (pVertices, g_Vertices, sizeof(g_Vertices));
	p_VertexBuffer->Unlock();

	ZeroMemory (&light, sizeof(D3DLIGHT8));
	light.Type = D3DLIGHT_DIRECTIONAL;

	light.Diffuse.r  = 1.0f;		//   
	light.Diffuse.g  = 1.0f;
	light.Diffuse.b  = 1.0f;

	vecDir = D3DXVECTOR3 (0.0f, 0.0f, 1.0f);
	D3DXVec3Normalize ((D3DXVECTOR3*)&light.Direction, &vecDir);

	light.Range = 1000.0f;

	p_d3d_Device->SetLight (0, &light);

	ZeroMemory (&mtrl1, sizeof(D3DMATERIAL8));
	mtrl1.Diffuse.r = mtrl1.Ambient.r = 0.0f;
	mtrl1.Diffuse.g = mtrl1.Ambient.g = 0.0f;
	mtrl1.Diffuse.b = mtrl1.Ambient.b = 1.0f;
	mtrl1.Diffuse.a = mtrl1.Ambient.a = 1.0f;

	ZeroMemory (&mtrl2, sizeof(D3DMATERIAL8));
	mtrl2.Diffuse.r = mtrl2.Ambient.r = 1.0f;
	mtrl2.Diffuse.g = mtrl2.Ambient.g = 1.0f;
	mtrl2.Diffuse.b = mtrl2.Ambient.b = 0.0f;
	mtrl2.Diffuse.a = mtrl2.Ambient.a = 1.0f;

	ZeroMemory (&mtrl3, sizeof(D3DMATERIAL8));
	mtrl3.Diffuse.r = mtrl3.Ambient.r = 0.0f;
	mtrl3.Diffuse.g = mtrl3.Ambient.g = 1.0f;
	mtrl3.Diffuse.b = mtrl3.Ambient.b = 0.0f;
	mtrl3.Diffuse.a = mtrl3.Ambient.a = 1.0f;

	//D3DXCreateTextureFromFile (p_d3d_Device, "01.jpg", &textura001);

	LoadMesh ("cubes1.x");

	MyFont.Init(p_d3d_Device, (HFONT)hFont);
}

void CMainWnd::LoadMesh (char *filename)
{
    LPD3DXBUFFER pD3DXMtrlBuffer;

    D3DXLoadMeshFromX (filename, D3DXMESH_SYSTEMMEM,
        p_d3d_Device, NULL, &pD3DXMtrlBuffer, &g_dwNumMaterials, &p_d3dx_mesh);

    D3DXMATERIAL* d3dxMaterials = (D3DXMATERIAL*)pD3DXMtrlBuffer->GetBufferPointer();

    g_pMeshMaterials = new D3DMATERIAL8[g_dwNumMaterials];
    g_pMeshTextures = new LPDIRECT3DTEXTURE8[g_dwNumMaterials];

    for( DWORD i=0; i<g_dwNumMaterials; i++ )
    {
        //  
        g_pMeshMaterials[i] = d3dxMaterials[i].MatD3D;

        //      (   D3DX)
        g_pMeshMaterials[i].Ambient = g_pMeshMaterials[i].Diffuse;

        //  
        if( FAILED( D3DXCreateTextureFromFile( p_d3d_Device, 
            d3dxMaterials[i].pTextureFilename, 
            &g_pMeshTextures[i] ) ) )
        {
            g_pMeshTextures[i] = NULL;
        }
    }
}

void CMainWnd::Transform3D(void)
{
	static float x; x+=(float)0.003;

	p_d3d_Device->LightEnable (0, true);

	D3DXMatrixRotationY (&matWorld, x);
	p_d3d_Device->SetTransform (D3DTS_WORLD, &matWorld);
  
	static float y=0; y+=(float)0.01;

	vecDir = D3DXVECTOR3 (sinf(y)*1, -cosf(y)*1, cosf(y)*1);
	D3DXVec3Normalize ((D3DXVECTOR3*)&light.Direction, &vecDir);
	p_d3d_Device->SetLight (0, &light);

	D3DXMatrixLookAtLH (&matView, &D3DXVECTOR3 (0.0f, 30.0f, -70.0f),
        &D3DXVECTOR3 (0.0f, 0.0f, 0.0f),
        &D3DXVECTOR3 (0.0f, 1.0f, 0.0f));
	p_d3d_Device->SetTransform (D3DTS_VIEW, &matView);
    
	D3DXMatrixPerspectiveFovLH (&matProj, D3DX_PI/4, 1.0f, 1.0f, 10000.0f);
	p_d3d_Device->SetTransform (D3DTS_PROJECTION, &matProj);

	p_d3d_Device->SetRenderState (D3DRS_CULLMODE, D3DCULL_NONE);
	p_d3d_Device->SetRenderState (D3DRS_LIGHTING, TRUE);
	p_d3d_Device->SetRenderState (D3DRS_ZENABLE, D3DZB_TRUE);
	p_d3d_Device->SetRenderState (D3DRS_AMBIENT, 0x55555555);
}

void CMainWnd::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	DestroyWindow();					//   
}

void CMainWnd::OnPaint()
{
    HRESULT hr;
	hr=p_d3d_Device->TestCooperativeLevel();
	
	if(hr==D3DERR_DEVICELOST) return;
	if (hr==D3DERR_DEVICENOTRESET)
	{
		p_d3d_Device->Reset(&d3dpp);
		Transform3D();
		MyFont.Restore();
	}

	SetCursor(NULL);

	Transform3D();
	
	p_d3d_Device->Clear (0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
		D3DCOLOR_XRGB (128, 128, 0), 1.0f, 0);

	p_d3d_Device->BeginScene ();

	p_d3d_Device->SetMaterial( &g_pMeshMaterials[0] );
	p_d3d_Device->SetTexture( 0, g_pMeshTextures[0] );
	//   
	p_d3dx_mesh->DrawSubset( 0 );

	p_d3d_Device->SetTexture( 0, g_pMeshTextures[1] );
	//   
	p_d3dx_mesh->DrawSubset( 1 );

	p_d3d_Device->SetTexture( 0, g_pMeshTextures[2] );
	//   
	p_d3dx_mesh->DrawSubset( 2 );

	p_d3d_Device->SetMaterial( &g_pMeshMaterials[3] );
	//   
	p_d3dx_mesh->DrawSubset( 3 );

	MyFont.Print (",   DirectX !!!", 300, 
		400, D3DCOLOR_XRGB (0,255,0));

	p_d3d_Device->EndScene ();

    p_d3d_Device->Present (NULL, NULL, NULL, NULL);
}

class CMyApp : public CWinApp
{
public: 
	CMyApp();							//    
	virtual BOOL InitInstance();		//  
};

CMyApp::CMyApp()						//    
{

}

BOOL CMyApp::InitInstance()				//  
{ 
	m_pMainWnd=new CMainWnd();			//    
	ASSERT(m_pMainWnd);					//    
	m_pMainWnd->ShowWindow(SW_SHOW);	//   
	m_pMainWnd->UpdateWindow();			//   
	
	return TRUE;						//    
};

CMyApp theApp;							//  